{smcl}
{* february2019}{...}
{hline}
help for {hi:rosali22}{right:Myriam Blanchin - Priscilla Brisson}
{hline}

{title:Detection of Response Shift at Item-Level between 2 times}

{p 8 14 2}{cmd:rosali22} {it:varlist} [{it:if}] [{it:in}] [, {cmdab:id}({it:string})
{cmdab:moda}({it:# # [#]...}) {cmdab:group}({it:string}) {cmdab:nodif}]

{p 4 4 4 140}{it:varlist} contains items' list : the first half of the items represents the items at time 1 and the second half the items at time 2. (at least 2 items).
{break}{it:Data} : wide format, one line for one patient

 {title:Description}

{p 4 12 2 140}{cmd:rosali22}: {bf:R}esp{bf:O}nse {bf:S}hift {bf:AL}gorithm at {bf:I}tem-level (ROSALI), 
detection of Response-Shift between two measuring times based on partial credit model.
Only uniform or non-uniform {bf:r}e{bf:c}alibration (RC) can be detected.
A dichotomous group covariate can affect the estimation of the true change(group effect) 
and of response shift detected.
Response shift can be common to both groups or differential.
Detection of {bf:d}ifferential {bf:i}tem {bf:f}unctionning (DIF) between two groups with the option group. 

{p 4 12 2 140} {ye:PART 1: DETECTION OF DIFFERENCE IN ITEM DIFFICULTIES BETWEEN GROUPS AT FIRST TIME OF MEASUREMENT}
{break} {it: Only with group option and without nodif option}
{break} {ye:Model A :} Full model, transversal PCM : estimates of item difficulties free between groups, estimates of latent trait with group effect constrained to 0.
{break} {ye:Model B :} Restricted model, transversal PCM : estimates of item difficulties with constraint of equality between groups, estimates of latent trait including group effect estimate.
{break} .LR test between model A and model B. If this test is significant, algorithm proceeds to step C, otherwise algorithm proceeds to part 2, with constraint of equality between groups of item difficulties.
{break} {ye:Step C :} an iterative step to detect which items have different item difficulties between groups at time 1. At each iteration, equality constraint of item difficulties between groups are relaxed one-by-one
producing multiple models C (starting with model B). For each item, difference in item difficulties between groups is tested, a Bonferroni correction is applied. Item with the most significant test is selected and tested 
to determine if the difference in item difficulties is uniform or non-uniform (if number of answer categories is greater to 2). Model C is updated and step C is repeated to identify differences on the remaining items. 
{break} .When there is no more item with significant test or only one remaining item to be tested, ROSALI goes on part 2.

{p 4 12 2 140} {ye:PART 2:  DETECTION OF DIFFERENCE IN ITEM DIFFICULTIES BETWEEN TIMES (RECALIBRATION)}
{break} For each model, algorithm takes account detection of part 1.
{break} {ye:Model 1 :} Full model, longitudinal PCM : estimates of item difficulties free across times for each group, estimates of latent trait with time effect and interaction time x group constrained to 0.
{break} {ye:Model 2 :} Restricted model, longitudinal PCM : estimates of item difficulties with constraint of equality across times, estimates of latent trait including time effect and interaction time x group estimate.
{break} .LR test between model 1 and model 2. If this test is significant, algorithm proceeds to step 3, otherwise algorithm proceeds to step 4, keeping model 2.
{break} {ye:Step 3 :} an iterative step to detect which items have different item difficulties across times. At each iteration, equality constraint of item difficulties between times are relaxed one-by-one producing multiple 
models 3 (starting with model 2). For each item, recalibration is tested, a Bonferroni correction is applied. Item with the most significant test is selected and tested. 
{break} .If group option, item is tested to determine if the difference in item difficulties is the same for each group (common RC), in this case, model 3 is updated to take account common recalibration, or different 
(differential RC), in this case, recalibration is tested for each group with a Bonferroni correction. 
{break} .Type of recalibration : uniform or non-uniform, is finally tested (if number of answer categories is greater to 2). Model 3 is updated and step 3 is repeated to identify differences on the remaining items. 
{break} .When there is no more item with significant test or only one remaining item to be tested, ROSALI goes on part 4.
{break} {ye:Model 4 :}  Item difficulties and latent trait are estimated with a longitudinal PCM taking account difference or no between groups or times and the type uniform or non-uniform. If interaction time x group is 
not significant model 4 is updated with constraint of interaction equal to 0 and we obtained final model.

{p 4 12 2 140} {cmd:automatic coding for answers categories}: Answers at items must be respect 2 conditions. If it is necessary algorithm recodes answers automatically. You can recodes answers before.
{break} - Answers must be ordered and start with 0. If it's necesary, algorithm recodes automatically answers categories to the first answer is 0.
{break} - It's necessary that all answers categories are used at two times of measurement (for each group if option was used).
{break}  .If the first answer is not used at one time (or in a group) at least: this answer is merged with next answer.
{break}  .If the last answer is not used at one time (or in a group) at least: this answer is merged with the previous answer.
{break}  .If an intermediate answer is not used at one time (or in one group) at least: this answer is merged with the next or previous answer of randomly way.
{break} {it: examples :} If there is 4 answers categories, answers lightly are : 0, 1, 2 or 3. 
{break} - If answer 0 is not used at one time or for one group, answers 0 and 1 merged (patient who had answered 0 or 1 have now the answer 0, the answer 2 became answer 1 and answer 3 became answer 2)
{break} - If answer 3 is not used at one time or for one group, answers 2 and 3 merged (patient who had answered 2 or 3 have now the answer 2, answers 0 and 1 remain the same)
{break} - If answer 1 (resp. 2) is not used at one time or for one group, randomly answer 1 (resp. 2) merged with answer 0  (resp. 1) or with answer 2 (resp. 3).
 
 {p 4 12 2 140} {cmd:automatic coding for groups}: Rosali needs to have one group 0 and one group 1. If it's necessary Rosali recodes group variable. You can recodes groups before.

 {title:Options}

{phang}{cmd:id}({it:string}) specifies the identifiant of individuals. Necessary to validate the data format.

{phang}{cmd:moda}({it:# # [#]...}) specifies the number of answers categories for each item.

{phang}{cmd:group}({it:string}) specifies the binary group variable, allows the detection of differential item functionning (DIF).

{phang}{cmd:nodif} specifies to do only the part 2 of algorithm. No detection of DIF, only detection of response shift for each group. {it:Use only with group option.}

{title:Outputs}

{p 2}{bf:Matrix:}

{phang}{cmd:r(test_model)}: Result of LRT between models A/B and models 1/2: chi-square, DF and p-value.

{phang}{cmd:r(model_#)}: Item difficulties and latent trait of model 2 and 4 : Estimates, standard error, confidence interval at 95%, chi-square, DF and p-value. 

{title:Examples}

{phang}{cmd: . rosali22 itemA1 itemA2 itemA3 itemB1 itemB2 itemB3, id(mat) } {it: // 3 items : A = time1 & B = time2 }

{phang}{cmd: . rosali22 it1_t1-it9_t2 , id(idpat) moda(4 4 7 7 7 7 7 7 7) group(type_c) } {it: // 9 items, 4 answers for two first items and seven for others, detection by group of type_c }

{title:Authors}

{phang} Myriam Blanchin, Research engineer, PhD, SPHERE - UMR INSERM U1246, "methodS in Patient-centered outomes and HEalth ResEarch", University of Nantes, France {browse "mailto:myriam.blanchin@univ-nantes.fr":myriam.blanchin@univ-nantes.fr}
{phang}Priscilla Brisson, SPHERE - UMR INSERM U1246, "methodS in Patient-centered outomes and HEalth ResEarch", University of Nantes, France
{browse "mailto:priscilla.brisson@univ-nantes.fr":priscilla.brisson@univ-nantes.fr}


